Binding of Isaac - Afterbirth+ Lua Reference/Guide

Functions
Isaac Namespace Reference

## Functions
| DebugString (string str)
EntityPlayer & | GetPlayer (integer playerId)
int | GetFrameCount ()
Entity & | Spawn (int entityType, int entityVariant, int entitySubtype, Vector position, Vector velocity, Entity Spawner)
| , const Vector& velocity = Vector::Zero); More...
GridEntity & | GridSpawn (int gridEntityType, int Variant, Vector position, boolean forced)
| RenderText (string str, float X, float Y, float R, float G, float B, float A)
| RenderScaledText (string str, float X, float Y, float ScaleX, float ScaleY, float R, float G, float B, float A)
integer | GetTextWidth (string str)
Vector | GetRandomPosition ()
Vector | GetFreeNearPosition (Vector pos, float step)
| Explode (Vector pos, Entity source, float damage)
integer | AddPillEffectToPool (integer pillEffect)
| returns pill color More...
table | GetRoomEntities ()
| returns all entities in the room More...
integer | GetChallenge ()
integer | GetEntityTypeByName (string entityName)
integer | GetEntityVariantByName (string entityName)
integer | GetItemIdByName (string itemName)
integer | GetPlayerTypeByName (string playerName)
integer | GetCardIdByName (string cardName)
integer | GetPillEffectByName (string pillEffect)
integer | GetTrinketIdByName (string trinketName)
integer | GetChallengeIdByName (string challengeName)
integer | GetCostumeIdByPath (string path)
integer | GetCurseIdByName (string curseName)
integer | GetSoundIdByName (string soundName)
integer | GetMusicIdByName (string musicName)
integer | GetTime ()
string | ExecuteCommand (string command)
| ConsoleOutput (string text)
Config & | GetItemConfig ()
table | FindInRadius (Vector Position, float Radius, integer Partitions)
| Returns entities in range of Radius from Position filtered by Partitions mask (see EntityPartition enum) (include all = 0xffffffff) More...
table | FindByType (integer Type, integer Variant, integer Subtype, boolean Cache, boolean IgnoreFriendly)
integer | CountEntities (Entity Spawner, integer Type, integer Variant, integer Subtype)
| Counts entities from SpawnerEntity (can be NULL) and/or Type (can be ENTITY_NULL), and/or Variant/Subtype (can be -1) More...
integer | CountBosses ()
integer | CountEnemies ()
| RegisterMod (table ref, string modName, integer apiVersion)
| Exposed methods. More...
| AddCallback (table ref, integer callbackId, table callbackFn, integer entityId)
| RemoveCallback (table ref, integer callbackId, table callbackFn)
| SaveModData (table ref, string data)
string | LoadModData (table ref)
boolean | HasModData (table ref)
| RemoveModData (table ref)
Vector | ScreenToWorld (Vector pos)
Vector | WorldToScreen (Vector pos)
Vector | WorldToScreenDistance (Vector pos)
Vector | WorldToRenderPosition (Vector pos)
Vector | ScreenToWorldDistance (Vector pos)

## Function Documentation

## ◆ AddCallback()

Isaac::AddCallback | ( | table | ref,
|  | integer | callbackId,
|  | table | callbackFn,
|  | integer | entityId
| ) |  |

## ◆ AddPillEffectToPool()

integer Isaac::AddPillEffectToPool | ( | integer | pillEffect | ) |

returns pill color

## ◆ ConsoleOutput()

Isaac::ConsoleOutput | ( | string | text | ) |

## ◆ CountBosses()

integer Isaac::CountBosses | ( |  | ) |

## ◆ CountEnemies()

integer Isaac::CountEnemies | ( |  | ) |

## ◆ CountEntities()

integer Isaac::CountEntities | ( | Entity | Spawner,
|  | integer | Type,
|  | integer | Variant,
|  | integer | Subtype
| ) |  |

Counts entities from SpawnerEntity (can be NULL) and/or Type (can be ENTITY_NULL), and/or Variant/Subtype (can be -1)

## ◆ DebugString()

Isaac::DebugString | ( | string | str | ) |

## ◆ ExecuteCommand()

string Isaac::ExecuteCommand | ( | string | command | ) |

## ◆ Explode()

Isaac::Explode | ( | Vector | pos,
|  | Entity | source,
|  | float | damage
| ) |  |

## ◆ FindByType()

table Isaac::FindByType | ( | integer | Type,
|  | integer | Variant,
|  | integer | Subtype,
|  | boolean | Cache,
|  | boolean | IgnoreFriendly
| ) |  |

Returns entities based on Type, Variant, Subtype. If Variant and/or Subtype is -1 then everything is included in that Variant/Subtype, Use Cache flag for multiple calls per frame.

## ◆ FindInRadius()

table Isaac::FindInRadius | ( | Vector | Position,
|  | float | Radius,
|  | integer | Partitions
| ) |  |

Returns entities in range of Radius from Position filtered by Partitions mask (see EntityPartition enum) (include all = 0xffffffff)

## ◆ GetCardIdByName()

integer Isaac::GetCardIdByName | ( | string | cardName | ) |

## ◆ GetChallenge()

integer Isaac::GetChallenge | ( |  | ) |

## ◆ GetChallengeIdByName()

integer Isaac::GetChallengeIdByName | ( | string | challengeName | ) |

## ◆ GetCostumeIdByPath()

integer Isaac::GetCostumeIdByPath | ( | string | path | ) |

## ◆ GetCurseIdByName()

integer Isaac::GetCurseIdByName | ( | string | curseName | ) |

## ◆ GetEntityTypeByName()

integer Isaac::GetEntityTypeByName | ( | string | entityName | ) |

## ◆ GetEntityVariantByName()

integer Isaac::GetEntityVariantByName | ( | string | entityName | ) |

## ◆ GetFrameCount()

int Isaac::GetFrameCount | ( |  | ) |

## ◆ GetFreeNearPosition()

Vector Isaac::GetFreeNearPosition | ( | Vector | pos,
|  | float | step
| ) |  |

## ◆ GetItemConfig()

Config& Isaac::GetItemConfig | ( |  | ) |

## ◆ GetItemIdByName()

integer Isaac::GetItemIdByName | ( | string | itemName | ) |

## ◆ GetMusicIdByName()

integer Isaac::GetMusicIdByName | ( | string | musicName | ) |

## ◆ GetPillEffectByName()

integer Isaac::GetPillEffectByName | ( | string | pillEffect | ) |

## ◆ GetPlayer()

EntityPlayer& Isaac::GetPlayer | ( | integer | playerId | ) |

## ◆ GetPlayerTypeByName()

integer Isaac::GetPlayerTypeByName | ( | string | playerName | ) |

## ◆ GetRandomPosition()

Vector Isaac::GetRandomPosition | ( |  | ) |

## ◆ GetRoomEntities()

table Isaac::GetRoomEntities | ( |  | ) |

returns all entities in the room

## ◆ GetSoundIdByName()

integer Isaac::GetSoundIdByName | ( | string | soundName | ) |

## ◆ GetTextWidth()

integer Isaac::GetTextWidth | ( | string | str | ) |

## ◆ GetTime()

integer Isaac::GetTime | ( |  | ) |

## ◆ GetTrinketIdByName()

integer Isaac::GetTrinketIdByName | ( | string | trinketName | ) |

## ◆ GridSpawn()

GridEntity& Isaac::GridSpawn | ( | int | gridEntityType,
|  | int | Variant,
|  | Vector | position,
|  | boolean | forced
| ) |  |

## ◆ HasModData()

boolean Isaac::HasModData | ( | table | ref | ) |

## ◆ LoadModData()

string Isaac::LoadModData | ( | table | ref | ) |

## ◆ RegisterMod()

Isaac::RegisterMod | ( | table | ref,
|  | string | modName,
|  | integer | apiVersion
| ) |  |

Exposed methods.

## ◆ RemoveCallback()

Isaac::RemoveCallback | ( | table | ref,
|  | integer | callbackId,
|  | table | callbackFn
| ) |  |

## ◆ RemoveModData()

Isaac::RemoveModData | ( | table | ref | ) |

## ◆ RenderScaledText()

Isaac::RenderScaledText | ( | string | str,
|  | float | X,
|  | float | Y,
|  | float | ScaleX,
|  | float | ScaleY,
|  | float | R,
|  | float | G,
|  | float | B,
|  | float | A
| ) |  |

## ◆ RenderText()

Isaac::RenderText | ( | string | str,
|  | float | X,
|  | float | Y,
|  | float | R,
|  | float | G,
|  | float | B,
|  | float | A
| ) |  |

## ◆ SaveModData()

Isaac::SaveModData | ( | table | ref,
|  | string | data
| ) |  |

## ◆ ScreenToWorld()

Vector Isaac::ScreenToWorld | ( | Vector | pos | ) |

## ◆ ScreenToWorldDistance()

Vector Isaac::ScreenToWorldDistance | ( | Vector | pos | ) |

## ◆ Spawn()

Entity& Isaac::Spawn | ( | int | entityType,
|  | int | entityVariant,
|  | int | entitySubtype,
|  | Vector | position,
|  | Vector | velocity,
|  | Entity | Spawner
| ) |  |

, const Vector& velocity = Vector::Zero);

## ◆ WorldToRenderPosition()

Vector Isaac::WorldToRenderPosition | ( | Vector | pos | ) |

## ◆ WorldToScreen()

Vector Isaac::WorldToScreen | ( | Vector | pos | ) |

## ◆ WorldToScreenDistance()

Vector Isaac::WorldToScreenDistance | ( | Vector | pos | ) |